//this is a very specialised class that allows the lookup of hypernym-hyponym relations such as 
//Akkubohrschrauber -- Bohrschrauber
//requires an input file that contains these hierarchies, created from compound split analysis

package ims.hotcoref.util;

import ims.hotcoref.Options;
import ims.hotcoref.data.Span;
import ims.hotcoref.features.enums.Gender;
import ims.hotcoref.features.enums.Num;
import ims.util.Util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Pattern;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

public class CompoundHierarchyLookup implements Serializable{
	private static final long serialVersionUID = 1L;
	

	public static HashMap<String,ArrayList<String>> compoundHierarchy=new HashMap<String,ArrayList<String>>();
	
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
	
		CompoundHierarchyLookup.lookupCompounds();
		
	/*	//for testing
		String[] examples={"Schonung"};
	
		for(String e:examples){
			System.out.println(e+" "+ compoundHierarchy.get(e)+"\n");
		}	*/
		
	
	}

public static void lookupCompounds () throws IOException, ClassNotFoundException {
		
			

			if(Options.compoundHierarchyList==null){
			System.out.println("didnt initialize compound hiearchy list -- no path given");
			}
		
			else {
				
			
		
			File f=Options.compoundHierarchyList;
		    //File f=new File("/mount/projekte14/ia/bosch/Arbeitspakete_2016/AP-4-Relationsextraktion/data/Sorted_Splits_Hierarchy");
			//File f=new File("/home/users0/roesigia/Desktop/test-hierarchy.txt");
		
			if (f.exists()){
				BufferedReader reader=Util.getReader(f);
				String line,line2;
				String currentHypernym, currentHyponym,lastHyponym="";
				
				while((line=reader.readLine())!=null&&line.length()!=0){		
					
					if (line.length()!=0){
						
						currentHypernym=line.split(" ")[0];
						
						//if next line is not empty
						while ((line2=reader.readLine())!=null&&line2.length()!=0){		
							currentHyponym=line2.replaceFirst("\t", "").split(" ")[0];
							
							//deeper level of embedding
							if (currentHyponym.contains("\t")){
								currentHyponym=currentHyponym.replace("\t","");
								ArrayList<String> tmp= new ArrayList<String>();
								if (compoundHierarchy.containsKey(currentHypernym)){tmp=compoundHierarchy.get(currentHypernym);}
								tmp.add(currentHyponym);
								compoundHierarchy.put(currentHypernym, tmp);
								ArrayList<String> tmp2= new ArrayList<String>();
								if (compoundHierarchy.containsKey(lastHyponym)){tmp2=compoundHierarchy.get(lastHyponym);}
								tmp2.add(currentHyponym);
								compoundHierarchy.put(lastHyponym,tmp2);							
								
							}
							//no further embedding
							else {
								ArrayList<String> tmp= new ArrayList<String>();
								if (compoundHierarchy.containsKey(currentHypernym)){
								tmp=compoundHierarchy.get(currentHypernym);}
								tmp.add(currentHyponym);
								compoundHierarchy.put(currentHypernym, tmp);
								lastHyponym=currentHyponym;

							}
						
						
						}lastHyponym="";
						}
						

					
					else {currentHypernym="";}
					
					
					
					
						
					}
				
				
				}
			}
			}
}
		
		
	
