//this is a very specialised class that allows the lookup of paraphrases such as
//president of the United States- US president, etc.
//requires an input file that contains these paraphrases

package ims.hotcoref.util;

import ims.hotcoref.Options;
import ims.hotcoref.data.Span;
import ims.hotcoref.features.enums.Gender;
import ims.hotcoref.features.enums.Num;
import ims.util.Util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Pattern;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

public class ParaphraseLookup implements Serializable{
	private static final long serialVersionUID = 1L;
	
	public static HashMap<String,ArrayList<String>> paraphrases=new HashMap<String,ArrayList<String>>();
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
	
		ParaphraseLookup.lookupParaphrases();
		
	/*	//for testing
		String[] examples={"Stangenscharnier-Montage"};
	
		for(String e:examples){
			System.out.println(e+" "+ paraphrases.get(e)+"\n");
		}	
		*/
	
	}

public static void lookupParaphrases () throws IOException, ClassNotFoundException {
		
			//file: contains compound splits for Tueba 9
	
			if(Options.paraphraseList==null){
			System.out.println("didnt initialize paraphrase list -- no path given");
			}
		
			else {
		
			//File f=new File("/mount/projekte14/ia/bosch/Arbeitspakete_2016/AP-4-Relationsextraktion/data/compounds-paraphrases.tsv");
			File f=Options.paraphraseList;//"/projekte/sfb-732/a6/Coref/CorefResolver/tueba9.splitted.aggr"
			if (f.exists()){
				BufferedReader reader=Util.getReader(f);
				String line;
				
				while((line=reader.readLine())!=null){		
					String word=line.split("\t")[0];
					String paraphrase=line.split("\t")[1];
					ArrayList<String> tmp= new ArrayList<String>();

					if (paraphrases.containsKey(word)){
						tmp=paraphrases.get(word);				
					}
					tmp.add(paraphrase);
					paraphrases.put(word,tmp);
				
				}
				
				
			}}
}
		
		
	
}